/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 6.1.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */

"use strict";var stringRemoveDuplicateHeadsTails=(()=>{var oe=Object.create;var A=Object.defineProperty;var ae=Object.getOwnPropertyDescriptor;var le=Object.getOwnPropertyNames,W=Object.getOwnPropertySymbols,ue=Object.getPrototypeOf,j=Object.prototype.hasOwnProperty,ge=Object.prototype.propertyIsEnumerable;var C=(e,n,s)=>n in e?A(e,n,{enumerable:!0,configurable:!0,writable:!0,value:s}):e[n]=s,d=(e,n)=>{for(var s in n||(n={}))j.call(n,s)&&C(e,s,n[s]);if(W)for(var s of W(n))ge.call(n,s)&&C(e,s,n[s]);return e};var he=(e,n)=>()=>(n||e((n={exports:{}}).exports,n),n.exports),ce=(e,n)=>{for(var s in n)A(e,s,{get:n[s],enumerable:!0})},B=(e,n,s,i)=>{if(n&&typeof n=="object"||typeof n=="function")for(let u of le(n))!j.call(e,u)&&u!==s&&A(e,u,{get:()=>n[u],enumerable:!(i=ae(n,u))||i.enumerable});return e};var fe=(e,n,s)=>(s=e!=null?oe(ue(e)):{},B(n||!e||!e.__esModule?A(s,"default",{value:e,enumerable:!0}):s,e)),me=e=>B(A({},"__esModule",{value:!0}),e);var J=(e,n,s)=>(C(e,typeof n!="symbol"?n+"":n,s),s);var G=he((Ve,P)=>{var pe="[object Object]";function ye(e){var n=!1;if(e!=null&&typeof e.toString!="function")try{n=!!(e+"")}catch(s){}return n}function de(e,n){return function(s){return e(n(s))}}var $e=Function.prototype,L=Object.prototype,q=$e.toString,be=L.hasOwnProperty,Te=q.call(Object),Oe=L.toString,we=de(Object.getPrototypeOf,Object);function Ee(e){return!!e&&typeof e=="object"}function Me(e){if(!Ee(e)||Oe.call(e)!=pe||ye(e))return!1;var n=we(e);if(n===null)return!0;var s=be.call(n,"constructor")&&n.constructor;return typeof s=="function"&&s instanceof s&&q.call(s)==Te}P.exports=Me});var Je={};ce(Je,{defaults:()=>ie,remDup:()=>Ce,version:()=>ke});var ne=fe(G(),1);function N(e){return typeof e!="string"?e:e.length?[e]:[]}function z(e){return!!e&&typeof e=="object"&&!Array.isArray(e)}function _(e){return typeof e=="string"}var U={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},De=e=>e+1;function Ne(e,n,s,i,u=!1,t=De){let a=typeof s=="function"?s():s;if(+n<0&&u&&a==="EOL")return a;let o=d(d({},U),i);if(n>=e.length&&!u)return!1;let l=u?1:s.length,r=0,f=!1,y=!1,m=!1,g=o.maxMismatches,c=n,h=!1,$=!1,p=!1;function O(){return r===1&&g<o.maxMismatches-1}for(;e[c];){let b=t(c);if(o.trimBeforeMatching&&e[c].trim()===""){if(!e[b]&&u&&s==="EOL")return!0;c=t(c);continue}if(o&&!o.i&&o.trimCharsBeforeMatching&&o.trimCharsBeforeMatching.includes(e[c])||(o==null?void 0:o.i)&&o.trimCharsBeforeMatching&&o.trimCharsBeforeMatching.map(E=>E.toLowerCase()).includes(e[c].toLowerCase())){if(u&&s==="EOL"&&!e[b])return!0;c=t(c);continue}let w=b>c?s[s.length-l]:s[l-1];if(!o.i&&e[c]===w||o.i&&e[c].toLowerCase()===w.toLowerCase()){if(h||(h=!0),m||(m=!0),l===s.length){if($=!0,g!==o.maxMismatches)return!1}else l===1&&(p=!0);if(l-=1,r++,O())return!1;if(!l)return r!==s.length||g===o.maxMismatches||!f?c:!1}else if(!f&&!r&&(f=!0),o.maxMismatches&&g&&c){g-=1;for(let E=0;E<=g;E++){let T=b>c?s[s.length-l+1+E]:s[l-2-E],S=e[t(c)];if(T&&(!o.i&&e[c]===T||o.i&&e[c].toLowerCase()===T.toLowerCase())&&(!o.firstMustMatch||l!==s.length)){if(r++,O())return!1;l-=2,h=!0;break}else if(S&&T&&(!o.i&&S===T||o.i&&S.toLowerCase()===T.toLowerCase())&&(!o.firstMustMatch||l!==s.length)){if(!r&&!o.hungry)return!1;l-=1,h=!0;break}else if(T===void 0&&g>=0&&h&&(!o.firstMustMatch||$)&&(!o.lastMustMatch||p))return c}h||(y=c)}else return c===0&&l===1&&!o.lastMustMatch&&m?0:!1;if(y!==!1&&y!==c&&(y=!1),l<1)return c;c=t(c)}if(l>0)return u&&a==="EOL"?!0:o&&o.maxMismatches>=l&&m?y||0:!1}function K(e,n,s,i,u){var f,y;if(z(u)&&Object.prototype.hasOwnProperty.call(u,"trimBeforeMatching")&&u&&typeof u.trimBeforeMatching!="boolean")throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(u.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);let t=d(d({},U),u);if(typeof t.trimCharsBeforeMatching=="string"&&(t.trimCharsBeforeMatching=N(t.trimCharsBeforeMatching)),t.trimCharsBeforeMatching=t.trimCharsBeforeMatching.map(m=>_(m)?m:String(m)),!_(n)||!n.length)return!1;if(!Number.isInteger(s)||s<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof s}, equal to:
${JSON.stringify(s,null,4)}`);let a,o;if(_(i))a=[i];else if(Array.isArray(i))a=i;else if(!i)a=i;else if(typeof i=="function")a=[],a.push(i);else throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof i}, equal to:
${JSON.stringify(i,null,4)}`);if(u&&!z(u))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof u}", and equal to:
${JSON.stringify(u,null,4)}`);let l=0,r="";if((t==null?void 0:t.trimCharsBeforeMatching)&&t.trimCharsBeforeMatching.some((m,g)=>m.length>1?(l=g,r=m,!0):!1))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${l} is longer than 1 character, ${r.length} (equals to ${r}). Please split it into separate characters and put into array as separate elements.`);if(!a||!Array.isArray(a)||Array.isArray(a)&&!a.length||Array.isArray(a)&&a.length===1&&_(a[0])&&!a[0].trim()){if(typeof t.cb=="function"){let g,c=s;if((e==="matchLeftIncl"||e==="matchRight")&&(c+=1),e[5]==="L")for(let O=c;O--;){let b=n[O];if((!t.trimBeforeMatching||t.trimBeforeMatching&&b!==void 0&&b.trim())&&(!((f=t.trimCharsBeforeMatching)!=null&&f.length)||b!==void 0&&!t.trimCharsBeforeMatching.includes(b))){g=O;break}}else if(e.startsWith("matchRight"))for(let O=c;O<n.length;O++){let b=n[O];if((!t.trimBeforeMatching||t.trimBeforeMatching&&b.trim())&&(!((y=t.trimCharsBeforeMatching)!=null&&y.length)||!t.trimCharsBeforeMatching.includes(b))){g=O;break}}if(g===void 0)return!1;let h=n[g],$=g+1,p="";return $&&$>0&&(p=n.slice(0,$)),e[5]==="L"||g&&g>0&&(p=n.slice(g)),t.cb(h,p,g)}let m="";throw u||(m=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${m}`)}for(let m=0,g=a.length;m<g;m++){o=typeof a[m]=="function";let c=a[m],h,$,p="",O=s;e==="matchRight"?O+=1:e==="matchLeft"&&(O-=1);let b=Ne(n,O,c,t,o,w=>e[5]==="L"?w-1:w+1);if(b&&o&&typeof c=="function"&&c()==="EOL")return c()&&(t.cb?t.cb(h,p,$):!0)?c():!1;if(Number.isInteger(b)&&($=e.startsWith("matchLeft")?b-1:b+1,e[5]==="L"?p=n.slice(0,b):p=n.slice($)),$<0&&($=void 0),n[$]&&(h=n[$]),Number.isInteger(b)&&(t.cb?t.cb(h,p,$):!0))return c}return!1}function F(e,n,s,i){return K("matchLeftIncl",e,n,s,i)}function I(e,n,s,i){return K("matchRightIncl",e,n,s,i)}function k(e,n=1){let s="\xA0";function i(t){return Array.from(t).reverse().join("")}function u(t,a,o){let l=o?`
`:"\r",r=o?"\r":`
`;if(!t)return t;let f=0,y=0,m="";for(let g=0,c=t.length;g<c;g++)(t[g]===l||t[g]===r&&t[g-1]!==l)&&y++,`\r
`.includes(t[g])||t[g]===s?(f=0,t[g]===s?m+=t[g]:t[g]===l?y<=a&&(m+=t[g],t[g+1]===r&&(m+=t[g+1],g++)):t[g]===r&&(t==null?void 0:t[g-1])!==l&&y<=a&&(m+=t[g])):(f++,!t[g+1]&&!y&&(m+=" "));return m}if(typeof e=="string"&&e.length){let t=1;typeof+n=="number"&&Number.isInteger(+n)&&+n>=0&&(t=+n);let a="",o="";if(!e.trim())a=e;else if(!e[0].trim()){for(let l=0,r=e.length;l<r;l++)if(e[l].trim()){a=e.slice(0,l);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===s)){for(let l=e.length;l--;)if(e[l].trim()){o=e.slice(l+1);break}}return`${u(a,t,!1)}${e.trim()}${i(u(i(o),t,!0))}`}return e}var Ie={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function Q(e,n){if(!Array.isArray(e)||!e.length)return e;let s=d(d({},Ie),n),i,u;if(s.strictlyTwoElementsInRangeArrays&&!e.every((o,l)=>!Array.isArray(o)||o.length!==2?(i=l,u=o.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) has not two but ${u} elements!`);if(!e.every((o,l)=>!Array.isArray(o)||!Number.isInteger(o[0])||o[0]<0||!Number.isInteger(o[1])||o[1]<0?(i=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,a=0;return Array.from(e).sort((o,l)=>(s.progressFn&&(a+=1,s.progressFn(Math.floor(a*100/t))),o[0]===l[0]?o[1]<l[1]?-1:o[1]>l[1]?1:0:o[0]<l[0]?-1:1))}var X={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Ae(e,n){function s(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let i;if(n)if(s(n)){if(i=d(d({},X),n),i.progressFn&&s(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&typeof i.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(![1,2,"1","2"].includes(i.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);if(typeof i.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(n,null,4)} (type ${typeof n})`);else i=d({},X);let u=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,a,o;i.progressFn?t=Q(u,{progressFn:r=>{o=Math.floor(r/5),o!==a&&(a=o,i.progressFn(o))}}):t=Q(u);let l=t.length-1;for(let r=l;r>0;r--)i.progressFn&&(o=Math.floor((1-r/l)*78)+21,o!==a&&o>a&&(a=o,i.progressFn(o))),(t[r][0]<=t[r-1][0]||!i.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||i.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+i.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}function M(e){return e!=null}function D(e){return Number.isInteger(e)&&e>=0}function v(e){return typeof e=="string"}var ve={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},H=class{constructor(e){J(this,"ranges");J(this,"opts");let n=d(d({},ve),e);if(n.mergeType&&n.mergeType!==1&&n.mergeType!==2)if(v(n.mergeType)&&n.mergeType.trim()==="1")n.mergeType=1;else if(v(n.mergeType)&&n.mergeType.trim()==="2")n.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);this.opts=n,this.ranges=[]}add(e,n,s){var t;if(e==null&&n==null)return;if(M(e)&&!M(n)){if(Array.isArray(e)){if(e.length){if(e.some(a=>Array.isArray(a))){e.forEach(a=>{Array.isArray(a)&&this.add(...a)});return}e.length&&D(+e[0])&&D(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(n,null,0)})`)}else if(!M(e)&&M(n))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(n,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let i=+e,u=+n;if(D(s)&&(s=String(s)),D(i)&&D(u)){if(M(s)&&!v(s)&&!D(s))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof s}, equal to:
${JSON.stringify(s,null,4)}`);if(M(this.ranges)&&Array.isArray(this.last())&&i===this.last()[1]){if(this.last()[1]=u,this.last()[2],this.last()[2]!==null&&M(s)){let a=this.last()[2]&&this.last()[2].length&&(!((t=this.opts)!=null&&t.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${s}`:s;this.opts.limitToBeAddedWhitespace&&(a=k(a,this.opts.limitLinebreaksCount)),v(a)&&!a.length||(this.last()[2]=a)}}else{this.ranges||(this.ranges=[]);let a=s!==void 0&&!(v(s)&&!s.length)?[i,u,s&&this.opts.limitToBeAddedWhitespace?k(s,this.opts.limitLinebreaksCount):s]:[i,u];this.ranges.push(a)}}else throw D(i)&&i>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof u}" equal to: ${JSON.stringify(u,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof i}" equal to: ${JSON.stringify(i,null,4)}`)}push(e,n,s){this.add(e,n,s)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=Ae(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>M(e[2])?[e[0],e[1],k(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&D(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var Re={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function V(e,n){if(!Array.isArray(e)||!e.length)return e;let s=d(d({},Re),n),i,u;if(s.strictlyTwoElementsInRangeArrays&&!e.every((o,l)=>!Array.isArray(o)||o.length!==2?(i=l,u=o.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) has not two but ${u} elements!`);if(!e.every((o,l)=>!Array.isArray(o)||!Number.isInteger(o[0])||o[0]<0||!Number.isInteger(o[1])||o[1]<0?(i=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,a=0;return Array.from(e).sort((o,l)=>(s.progressFn&&(a+=1,s.progressFn(Math.floor(a*100/t))),o[0]===l[0]?o[1]<l[1]?-1:o[1]>l[1]?1:0:o[0]<l[0]?-1:1))}var Y={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Z(e,n){function s(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let i;if(n)if(s(n)){if(i=d(d({},Y),n),i.progressFn&&s(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&typeof i.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(![1,2,"1","2"].includes(i.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);if(typeof i.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(n,null,4)} (type ${typeof n})`);else i=d({},Y);let u=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,a,o;i.progressFn?t=V(u,{progressFn:r=>{o=Math.floor(r/5),o!==a&&(a=o,i.progressFn(o))}}):t=V(u);let l=t.length-1;for(let r=l;r>0;r--)i.progressFn&&(o=Math.floor((1-r/l)*78)+21,o!==a&&o>a&&(a=o,i.progressFn(o))),(t[r][0]<=t[r-1][0]||!i.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||i.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+i.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}var Se=!0,x="Invariant failed";function ee(e,n){if(!e){if(Se)throw new Error(x);var s=typeof n=="function"?n():n,i=s?"".concat(x,": ").concat(s):x;throw new Error(i)}}function te(e,n,s){let i=0,u=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(n&&!Array.isArray(n))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(s&&typeof s!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s,null,4)}`);if(!n||!n.filter(f=>f).length)return e;let t;Array.isArray(n)&&Number.isInteger(n[0])&&Number.isInteger(n[1])?t=[Array.from(n)]:t=Array.from(n);let a=t.length,o=0;t.filter(f=>f).forEach((f,y)=>{if(s&&(i=Math.floor(o/a*10),i!==u&&(u=i,s(i))),!Array.isArray(f))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${y}th element not an array: ${JSON.stringify(f,null,4)}, which is ${typeof f}`);if(!Number.isInteger(f[0])){if(!Number.isInteger(+f[0])||+f[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${y}th element, array ${JSON.stringify(f,null,0)}. Its first element is not an integer, string index, but ${typeof f[0]}, equal to: ${JSON.stringify(f[0],null,4)}.`);t[y][0]=+t[y][0]}if(!Number.isInteger(f[1])){if(!Number.isInteger(+f[1])||+f[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${y}th element, array ${JSON.stringify(f,null,0)}. Its second element is not an integer, string index, but ${typeof f[1]}, equal to: ${JSON.stringify(f[1],null,4)}.`);t[y][1]=+t[y][1]}o+=1});let l=Z(t,{progressFn:f=>{s&&(i=10+Math.floor(f/10),i!==u&&(u=i,s(i)))}});ee(l);let r=l.length;if(r>0){let f=e.slice(l[r-1][1]);e=l.reduce((y,m,g,c)=>{s&&(i=20+Math.floor(g/r*80),i!==u&&(u=i,s(i)));let h=g===0?0:c[g-1][1],$=c[g][0];return`${y}${e.slice(h,$)}${c[g][2]||""}`},""),e+=f}return e}var _e={classicTrim:!1,cr:!1,lf:!1,tab:!1,space:!0,nbsp:!1};function R(e,n){if(typeof e!="string")throw new Error(`string-trim-spaces-only: [THROW_ID_01] input must be string! It was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);let s=d(d({},_e),n);function i(a){return s.classicTrim&&!a.trim()||!s.classicTrim&&(s.space&&a===" "||s.cr&&a==="\r"||s.lf&&a===`
`||s.tab&&a==="	"||s.nbsp&&a==="\xA0")}let u,t;if(e.length){if(i(e[0]))for(let a=0,o=e.length;a<o;a++){if(!i(e[a])){u=a;break}if(a===e.length-1)return{res:"",ranges:[[0,e.length]]}}if(i(e[e.length-1])){for(let a=e.length;a--;)if(!i(e[a])){t=a+1;break}}return u?t?{res:e.slice(u,t),ranges:[[0,u],[t,e.length]]}:{res:e.slice(u),ranges:[[0,u]]}:t?{res:e.slice(0,t),ranges:[[t,e.length]]}:{res:e,ranges:[]}}return{res:"",ranges:[]}}var re="6.1.7";var ke=re,ie={heads:["{{"],tails:["}}"]};function Ce(e,n){let s=Object.prototype.hasOwnProperty;if(e===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof e!="string")return e;if(n&&!(0,ne.default)(n))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof n}!`);let i=d({},n);if(i&&s.call(i,"heads"))if(N(i.heads).every(h=>typeof h=="string"||Array.isArray(h)))typeof i.heads=="string"&&(i.heads=N(i.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The resolvedOpts.heads contains elements which are not string-type!");if(i&&s.call(i,"tails"))if(N(i.tails).every(h=>typeof h=="string"||Array.isArray(h)))typeof i.tails=="string"&&(i.tails=N(i.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The resolvedOpts.tails contains elements which are not string-type!");let u=R(e).res;if(u.length===0)return e;e=u;let t=d(d({},ie),i);t.heads=t.heads.map(h=>h.trim()),t.tails=t.tails.map(h=>h.trim());let a=!1,o=!1,l=new H({limitToBeAddedWhitespace:!0}),r=new H({limitToBeAddedWhitespace:!0}),f=!0,y=!0,m="";function g(h,$){let p;return I(h,0,$.heads,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})&&I(h,p,$.tails,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})?h.slice(p):h}for(;e!==g(e,t);)e=R(g(e,t)).res;function c(h,$){let p;return!F(h,h.length-1,$.tails,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})||!p?h:F(h,p,$.heads,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})?h.slice(0,p+1):h}for(;e!==c(e,t);)e=R(c(e,t)).res;if(!t.heads.length||!I(e,0,t.heads,{trimBeforeMatching:!0})||!t.tails.length||!F(e,e.length-1,t.tails,{trimBeforeMatching:!0}))return R(e).res;for(let h=0,$=e.length;h<$;h++)if(e[h].trim()!==""){let p;if(I(e,h,t.heads,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})&&p){y=!0,f&&(f=!0);let w;I(e,p,t.tails,{trimBeforeMatching:!0,cb:(T,S,se)=>(w=se,!0)})&&l.push(h,w),r.current()&&a&&m!=="tails"&&l.push(r.current()),a||r.current()&&(l.push(r.current()),r.wipe()),r.push(h,p),m="heads",h=p-1;continue}if(I(e,h,t.tails,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=Number.isInteger(T)?T:e.length,!0)})&&p){y=!0,f?(m==="heads"&&r.wipe(),f=!1):r.push(h,p),m="tails",h=p-1;continue}f&&(f=!0),y&&!a?(a=!0,y=!1):y&&!o?(o=!0,f=!0,y=!1,m==="heads"&&r.wipe()):y&&o&&r.wipe()}return r.current()&&l.push(r.current()),l.current()?te(e,l.current()).trim():e.trim()}return me(Je);})();
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 4.1.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 6.2.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 8.2.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 6.2.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 5.1.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 6.1.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 8.2.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
/**
 * @name string-trim-spaces-only
 * @fileoverview Like String.trim() but you can choose granularly what to trim
 * @version 4.1.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-trim-spaces-only/}
 */
